/***************************************************************************

	z80intf.c

	Handling RAZE Z80 core.

***************************************************************************/

#ifndef Z80INTF_H
#define Z80INTF_H

#include "raze.h"

extern int z80_ICount;

void z80_init(void);
void z80_reset(int param);
void z80_exit(void);
int  z80_execute(int cycles);
void z80_burn(int cycles);
void z80_set_irq_line(int irqline, int state);
void z80_set_irq_callback(int (*callback)(int irqline));
void z80_enable(int enable);
void z80_save_context(void);
void z80_restore_context(void);

#endif /* Z80INTF_H */
